std::is_unsigned(3)

NAME
std::is_unsigned - std::is_unsigned

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++11)
   struct is_unsigned;
   If T is an integral type, provides the member constant value equal to true if T(0) <
   T(-1): this results in true for the unsigned integer types and the type bool and in
   false for the signed integer types and the floating-point types.
   For any other type, value is false.
   The behavior of a program that adds specializations for is_unsigned
   or is_unsigned_v
   (since C++17) is undefined.

Template parameters
   T - a type to check
  Helper variable template
   template< class T > (since C++17)
   inline constexpr bool is_unsigned_v = is_unsigned<T>::value; Inherited from std::integral_constant

Member constants
   value true if T is an unsigned integral type , false otherwise
   [static] (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Possible implementation
   namespace detail {
   template<typename T,bool = std::is_arithmetic<T>::value>
   struct is_unsigned : std::integral_constant<bool, T(0) < T(-1)> {};
   template<typename T>
   struct is_unsigned<T,false> : std::false_type {};
   } // namespace detail
   template<typename T>
   struct is_unsigned : detail::is_unsigned<T>::type {};

Example
// Run this code
 #include <iostream>
 #include <type_traits>
 class A {};
 enum B : unsigned {};
 enum class C : unsigned {};
 int main()
 {
     std::cout << std::boolalpha;
     std::cout << std::is_unsigned<A>::value << '\n';
     std::cout << std::is_unsigned<float>::value << '\n';
     std::cout << std::is_unsigned<signed int>::value << '\n';
     std::cout << std::is_unsigned<unsigned int>::value << '\n';
     std::cout << std::is_unsigned<B>::value << '\n';
     std::cout << std::is_unsigned<C>::value << '\n';
 }

Output:
 false
 false
 false
 true
 false
 false

See also
   is_signed checks if a type is a signed arithmetic type
   (C++11) (class template)
   is_arithmetic checks if a type is an arithmetic type
   (C++11) (class template)
   make_signed makes the given integral type signed
   (C++11) (class template)
   make_unsigned makes the given integral type unsigned
   (C++11) (class template)